diff --git a/enrol/paypal/addinstance.php b/enrol/paypal/addinstance.php
new file mode 100644
index 0000000..bec46f3
--- /dev/null
+++ b/enrol/paypal/addinstance.php
@@ -0,0 +1,43 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Adds new instance of enrol_paypal to specified course.
+ *
+ * @package   enrol_paypal
+ * @copyright 2010 Eugene Venter
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+require('../../config.php');
+
+$id = required_param('id', PARAM_INT); // course id
+
+$course = $DB->get_record('course', array('id'=>$id), '*', MUST_EXIST);
+$context = get_context_instance(CONTEXT_COURSE, $course->id, MUST_EXIST);
+
+require_login($course);
+require_capability('moodle/course:enrolconfig', $context);
+require_sesskey();
+
+$enrol = enrol_get_plugin('paypal');
+
+if ($enrol->get_candidate_link($course->id)) {
+    $enrol->add_default_instance($course);
+}
+
+redirect(new moodle_url('/enrol/instances.php', array('id'=>$course->id)));
diff --git a/enrol/paypal/config.html b/enrol/paypal/config.html
deleted file mode 100644
index fbe55f7..0000000
--- a/enrol/paypal/config.html
+++ /dev/null
@@ -1,66 +0,0 @@
-<table cellspacing="0" cellpadding="5" border="0" class="boxaligncenter">
-
-<tr valign="top">
-    <td align="right">enrol_cost:</td>
-    <td>
-        <input type="text" size="5" name="enrol_cost" value="<?php echo $frm->enrol_cost ?>" />
-    </td>
-    <td>
-    <?php  print_string("costdefault") ?>
-    </td>
-</tr>
-
-<tr valign="top">
-    <td align="right">enrol_currency:</td>
-    <td>
-    <?php
-        global $OUTPUT;
-        echo html_writer::select($paypalcurrencies, "enrol_currency", $frm->enrol_currency, false);
-    ?>
-    </td>
-    <td>
-    <?php  print_string("currency") ?>
-    </td>
-</tr>
-
-<tr valign="top">
-    <td align="right">enrol_paypalbusiness:</td>
-    <td>
-        <input type="text" name="enrol_paypalbusiness" value="<?php echo $frm->enrol_paypalbusiness ?>" />
-    </td>
-    <td>
-    <?php  print_string("business", "enrol_paypal") ?>
-    </td>
-</tr>
-
-<tr valign="top">
-    <td align="right">enrol_mailstudents:</td>
-    <td>
-        <input type="checkbox" value="1" name="enrol_mailstudents" <?php if ($frm->enrol_mailstudents) echo "checked=\"checked\"" ?> />
-    </td>
-    <td>
-    <?php  print_string("mailstudents") ?>
-    </td>
-</tr>
-
-<tr valign="top">
-    <td align="right">enrol_mailteachers:</td>
-    <td>
-        <input type="checkbox" value="1" name="enrol_mailteachers" <?php if ($frm->enrol_mailteachers) echo "checked=\"checked\"" ?> />
-    </td>
-    <td>
-    <?php  print_string("mailteachers") ?>
-    </td>
-</tr>
-
-<tr valign="top">
-    <td align="right">enrol_mailadmins:</td>
-    <td>
-        <input type="checkbox" value="1" name="enrol_mailadmins" <?php if ($frm->enrol_mailadmins) echo "checked=\"checked\"" ?> />
-    </td>
-    <td>
-    <?php  print_string("mailadmins") ?>
-    </td>
-</tr>
-
-</table>
diff --git a/enrol/paypal/db/install.xml b/enrol/paypal/db/install.xml
index f7f26d4..387234d 100644
--- a/enrol/paypal/db/install.xml
+++ b/enrol/paypal/db/install.xml
@@ -1,5 +1,8 @@
 <?xml version="1.0" encoding="UTF-8" ?>
-<XMLDB PATH="enrol/paypal/db" VERSION="20060807" COMMENT="XMLDB file for Moodle enrol/paypal">
+<XMLDB PATH="enrol/paypal/db" VERSION="20100716" COMMENT="XMLDB file for Moodle enrol/paypal"
+    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+    xsi:noNamespaceSchemaLocation="../../../lib/xmldb/xmldb.xsd"
+>
   <TABLES>
     <TABLE NAME="enrol_paypal" COMMENT="Holds all known information about PayPal transactions">
       <FIELDS>
@@ -9,8 +12,9 @@
         <FIELD NAME="receiver_id" TYPE="char" LENGTH="255" NOTNULL="true" SEQUENCE="false" PREVIOUS="receiver_email" NEXT="item_name"/>
         <FIELD NAME="item_name" TYPE="char" LENGTH="255" NOTNULL="true" SEQUENCE="false" PREVIOUS="receiver_id" NEXT="courseid"/>
         <FIELD NAME="courseid" TYPE="int" LENGTH="10" NOTNULL="true" UNSIGNED="true" DEFAULT="0" SEQUENCE="false" PREVIOUS="item_name" NEXT="userid"/>
-        <FIELD NAME="userid" TYPE="int" LENGTH="10" NOTNULL="true" UNSIGNED="true" DEFAULT="0" SEQUENCE="false" PREVIOUS="courseid" NEXT="memo"/>
-        <FIELD NAME="memo" TYPE="char" LENGTH="255" NOTNULL="true" SEQUENCE="false" PREVIOUS="userid" NEXT="tax"/>
+        <FIELD NAME="userid" TYPE="int" LENGTH="10" NOTNULL="true" UNSIGNED="true" DEFAULT="0" SEQUENCE="false" PREVIOUS="courseid" NEXT="instanceid"/>
+        <FIELD NAME="instanceid" TYPE="int" LENGTH="10" NOTNULL="true" UNSIGNED="true" DEFAULT="0" SEQUENCE="false" PREVIOUS="userid" NEXT="memo"/>
+        <FIELD NAME="memo" TYPE="char" LENGTH="255" NOTNULL="true" SEQUENCE="false" PREVIOUS="instanceid" NEXT="tax"/>
         <FIELD NAME="tax" TYPE="char" LENGTH="255" NOTNULL="true" SEQUENCE="false" PREVIOUS="memo" NEXT="option_name1"/>
         <FIELD NAME="option_name1" TYPE="char" LENGTH="255" NOTNULL="true" SEQUENCE="false" PREVIOUS="tax" NEXT="option_selection1_x"/>
         <FIELD NAME="option_selection1_x" TYPE="char" LENGTH="255" NOTNULL="true" SEQUENCE="false" PREVIOUS="option_name1" NEXT="option_name2"/>
@@ -25,8 +29,8 @@
         <FIELD NAME="timeupdated" TYPE="int" LENGTH="10" NOTNULL="true" UNSIGNED="true" DEFAULT="0" SEQUENCE="false" PREVIOUS="payment_type"/>
       </FIELDS>
       <KEYS>
-        <KEY NAME="primary" TYPE="primary" FIELDS="id" />
+        <KEY NAME="primary" TYPE="primary" FIELDS="id"/>
       </KEYS>
     </TABLE>
   </TABLES>
-</XMLDB>
+</XMLDB>
\ No newline at end of file
diff --git a/enrol/paypal/db/upgrade.php b/enrol/paypal/db/upgrade.php
new file mode 100644
index 0000000..f04afc6
--- /dev/null
+++ b/enrol/paypal/db/upgrade.php
@@ -0,0 +1,43 @@
+<?php
+
+// This file keeps track of upgrades to
+// the paypal enrolment plugin
+//
+// Sometimes, changes between versions involve
+// alterations to database structures and other
+// major things that may break installations.
+//
+// The upgrade function in this file will attempt
+// to perform all the necessary actions to upgrade
+// your older installation to the current version.
+//
+// If there's something it cannot do itself, it
+// will tell you what you need to do.
+//
+// The commands in here will all be database-neutral,
+// using the methods of database_manager class
+//
+// Please do not forget to use upgrade_set_timeout()
+// before any action that may take longer time to finish.
+
+function xmldb_enrol_paypal_upgrade($oldversion) {
+    global $CFG, $DB, $OUTPUT;
+
+    $dbman = $DB->get_manager();
+
+    // Add instanceid field to enrol_paypal table
+    if ($oldversion < 2010071500) {
+        $table = new xmldb_table('enrol_paypal');
+        $field = new xmldb_field('instanceid');
+        if (!$dbman->field_exists($table, $field)) {
+            $field->set_attributes(XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, 0, 'userid');
+            $dbman->add_field($table, $field);
+        }
+        upgrade_plugin_savepoint(true, 2010071500, 'enrol', 'paypal');
+    }
+
+    //===== 1.9.0 upgrade line ======//
+
+
+    return true;
+}
diff --git a/enrol/paypal/enrol.html b/enrol/paypal/enrol.html
index d289d3d..3bfc11e 100644
--- a/enrol/paypal/enrol.html
+++ b/enrol/paypal/enrol.html
@@ -1,7 +1,7 @@
 <div align="center">
 
 <p><?php print_string("paymentrequired") ?></p>
-<p><b><?php echo get_string("cost").": $CFG->enrol_currency $cost"; ?></b></p>
+<p><b><?php echo get_string("cost").": {$instance->currency} {$cost}"; ?></b></p>
 <p><img alt="<?php print_string('paypalaccepted', 'enrol_paypal') ?>" src="https://www.paypal.com/en_US/i/logo/PayPal_mark_60x38.gif" /></p>
 <p><?php print_string("paymentinstant") ?></p>
 <?php
@@ -11,15 +11,15 @@
 
 <input type="hidden" name="cmd" value="_xclick" />
 <input type="hidden" name="charset" value="utf-8" />
-<input type="hidden" name="business" value="<?php p($CFG->enrol_paypalbusiness)?>" />
+<input type="hidden" name="business" value="<?php p($this->get_config('paypalbusiness'))?>" />
 <input type="hidden" name="item_name" value="<?php p($coursefullname) ?>" />
 <input type="hidden" name="item_number" value="<?php p($courseshortname) ?>" />
 <input type="hidden" name="quantity" value="1" />
 <input type="hidden" name="on0" value="<?php print_string("user") ?>" />
 <input type="hidden" name="os0" value="<?php p($userfullname) ?>" />
-<input type="hidden" name="custom" value="<?php echo "$USER->id-$course->id" ?>" />
+<input type="hidden" name="custom" value="<?php echo "{$USER->id}-{$course->id}-{$instance->id}" ?>" />
 
-<input type="hidden" name="currency_code" value="<?php p($CFG->enrol_currency) ?>" />
+<input type="hidden" name="currency_code" value="<?php p($instance->currency) ?>" />
 <input type="hidden" name="amount" value="<?php p($cost) ?>" />
 
 <input type="hidden" name="for_auction" value="false" />
diff --git a/enrol/paypal/enrol.php b/enrol/paypal/enrol.php
deleted file mode 100644
index 67c9f03..0000000
--- a/enrol/paypal/enrol.php
+++ /dev/null
@@ -1,218 +0,0 @@
-<?php
-       // Implements all the main code for the PayPal plugin
-
-class enrolment_plugin_paypal {
-
-
-/// Override the base print_entry() function
-function print_entry($course) {
-    global $CFG, $USER, $OUTPUT, $PAGE;
-
-
-    $strloginto = get_string("loginto", "", $course->shortname);
-    $strcourses = get_string("courses");
-
-    $context = get_context_instance(CONTEXT_COURSE, $course->id);
-    // Pass $view=true to filter hidden caps if the user cannot see them
-    if ($users = get_users_by_capability($context, 'moodle/course:update', 'u.*', 'u.id ASC',
-                                         '', '', '', '', false, true)) {
-        $users = sort_by_roleassignment_authority($users, $context);
-        $teacher = array_shift($users);
-    } else {
-        $teacher = false;
-    }
-
-    if ( (float) $course->cost <= 0 ) {
-        $cost = (float) $CFG->enrol_cost;
-    } else {
-        $cost = (float) $course->cost;
-    }
-
-    if (abs($cost) < 0.01) { // no cost, default to base class entry to course
-
-        $manual = enrolment_factory::factory('manual');
-        $manual->print_entry($course);
-
-    } else {
-        $PAGE->navbar->add($strcourses, new moodle_url('/course/'));
-        $PAGE->navbar->add($strloginto);
-        $PAGE->set_title($strloginto);
-        $PAGE->set_heading($course->fullname);
-        echo $OUTPUT->header();
-        print_course($course, "80%");
-
-        if ($course->password) {  // Presenting two options
-            echo $OUTPUT->heading(get_string('costorkey', 'enrol_paypal'));
-        }
-
-        echo $OUTPUT->box_end();
-
-        if ($USER->username == 'guest') { // force login only for guest user, not real users with guest role
-            if (empty($CFG->loginhttps)) {
-                $wwwroot = $CFG->wwwroot;
-            } else {
-                // This actually is not so secure ;-), 'cause we're
-                // in unencrypted connection...
-                $wwwroot = str_replace("http://", "https://", $CFG->wwwroot);
-            }
-            echo '<div class="mdl-align"><p>'.get_string('paymentrequired').'</p>';
-            echo '<p><b>'.get_string('cost').": $CFG->enrol_currency $cost".'</b></p>';
-            echo '<p><a href="'.$wwwroot.'/login/">'.get_string('loginsite').'</a></p>';
-            echo '</div>';
-        } else {
-            //Sanitise some fields before building the PayPal form
-            $coursefullname  = $course->fullname;
-            $courseshortname = $course->shortname;
-            $userfullname    = fullname($USER);
-            $userfirstname   = $USER->firstname;
-            $userlastname    = $USER->lastname;
-            $useraddress     = $USER->address;
-            $usercity        = $USER->city;
-
-            include($CFG->dirroot.'/enrol/paypal/enrol.html');
-        }
-
-        echo $OUTPUT->box_end();
-
-        if ($course->password) {  // Second option
-            $password = '';
-            include($CFG->dirroot.'/enrol/manual/enrol.html');
-        }
-
-        echo $OUTPUT->footer();
-
-    }
-} // end of function print_entry()
-
-
-
-
-/// Override the get_access_icons() function
-function get_access_icons($course) {
-    global $CFG;
-
-    $str = '';
-
-    if ( (float) $course->cost < 0) {
-        $cost = (float) $CFG->enrol_cost;
-    } else {
-        $cost = (float) $course->cost;
-    }
-
-    if (abs($cost) < 0.01) {
-        $manual = enrolment_factory::factory('manual');
-        $str = $manual->get_access_icons($course);
-
-    } else {
-
-        $strrequirespayment = get_string("requirespayment");
-        $strcost = get_string("cost");
-
-        if (empty($CFG->enrol_currency)) {
-            set_config('enrol_currency', 'USD');
-        }
-
-        switch ($CFG->enrol_currency) {
-           case 'EUR': $currency = '&euro;'; break;
-           case 'CAD': $currency = '$'; break;
-           case 'GBP': $currency = '&pound;'; break;
-           case 'JPY': $currency = '&yen;'; break;
-           case 'AUD': $currency = '$'; break;
-           default:    $currency = '$'; break;
-        }
-
-        $str .= '<div class="cost" title="'.$strrequirespayment.'">'.$strcost.': ';
-        $str .= $currency.format_float($cost,2).'</div>';
-
-    }
-
-    return $str;
-}
-
-/// Override the base class config_form() function
-function config_form($frm) {
-    global $CFG;
-
-    $paypalcurrencies = array(  'USD' => 'US Dollars',
-                                'EUR' => 'Euros',
-                                'JPY' => 'Japanese Yen',
-                                'GBP' => 'British Pounds',
-                                'CAD' => 'Canadian Dollars',
-                                'AUD' => 'Australian Dollars'
-                             );
-
-    $vars = array('enrol_cost', 'enrol_currency', 'enrol_paypalbusiness',
-                  'enrol_mailstudents', 'enrol_mailteachers', 'enrol_mailadmins');
-    foreach ($vars as $var) {
-        if (!isset($frm->$var)) {
-            $frm->$var = '';
-        }
-    }
-
-    include("$CFG->dirroot/enrol/paypal/config.html");
-}
-
-function process_config($config) {
-
-    if (!isset($config->enrol_cost)) {
-        $config->enrol_cost = 0;
-    }
-    set_config('enrol_cost', $config->enrol_cost);
-
-    if (!isset($config->enrol_currency)) {
-        $config->enrol_currency = 'USD';
-    }
-    set_config('enrol_currency', $config->enrol_currency);
-
-    if (!isset($config->enrol_paypalbusiness)) {
-        $config->enrol_paypalbusiness = '';
-    }
-    $config->enrol_paypalbusiness = trim($config->enrol_paypalbusiness); // remove trailing spaces etc.
-    set_config('enrol_paypalbusiness', $config->enrol_paypalbusiness);
-
-    if (!isset($config->enrol_mailstudents)) {
-        $config->enrol_mailstudents = '';
-    }
-    set_config('enrol_mailstudents', $config->enrol_mailstudents);
-
-    if (!isset($config->enrol_mailteachers)) {
-        $config->enrol_mailteachers = '';
-    }
-    set_config('enrol_mailteachers', $config->enrol_mailteachers);
-
-    if (!isset($config->enrol_mailadmins)) {
-        $config->enrol_mailadmins = '';
-    }
-    set_config('enrol_mailadmins', $config->enrol_mailadmins);
-
-    return true;
-
-}
-
-/**
-* This function enables internal enrolment when PayPal is primary and course key is set at the same time.
-*
-* @param    form    the form data submitted, as an object
-* @param    course  the current course, as an object
-*/
-function check_entry($form, $course) {
-    $manual = enrolment_factory::factory('manual');
-    $manual->check_entry($form, $course);
-    if (isset($manual->errormsg)) {
-        $this->errormsg = $manual->errormsg;
-    }
-}
-
-/**
- * Provides method to print the enrolment key form code. This method is called
- * from /enrol/manual/enrol.html if it's included
- * @param  object a valid course object
- */
-function print_enrolmentkeyfrom($course) {
-    $manual = enrolment_factory::factory('manual');
-    $manual->print_enrolmentkeyfrom($course);
-}
-
-} // end of class definition
-
-
diff --git a/enrol/paypal/ipn.php b/enrol/paypal/ipn.php
index 4bab567..33991ee 100644
--- a/enrol/paypal/ipn.php
+++ b/enrol/paypal/ipn.php
@@ -1,4 +1,25 @@
 <?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * @package   enrol_paypal
+ * @copyright 2010 Eugene Venter
+ * @author    Eugene Venter - based on code by others
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
 
 /**
 * Listens for Instant Payment Notification from PayPal
@@ -6,259 +27,282 @@
 * This script waits for Payment notification from PayPal,
 * then double checks that data by sending it back to PayPal.
 * If PayPal verifies this then it sets up the enrolment for that
+* user.
 *
-* Set the $user->timeaccess course array
-*
-* @param    user  referenced object, must contain $user->id already set
 */
 
 
-    require("../../config.php");
-    require("enrol.php");
-    require_once($CFG->libdir.'/eventslib.php');
+require("../../config.php");
+require("lib.php");
+require_once($CFG->libdir.'/eventslib.php');
+require_once($CFG->libdir.'/enrollib.php');
+
 
 /// Keep out casual intruders
-    if (empty($_POST) or !empty($_GET)) {
-        print_error("Sorry, you can not use the script that way.");
-    }
+if (empty($_POST) or !empty($_GET)) {
+    print_error("Sorry, you can not use the script that way.");
+}
 
 /// Read all the data from PayPal and get it ready for later;
 /// we expect only valid UTF-8 encoding, it is the responsibility
-/// of user to set it up properly in PayPal business acount,
+/// of user to set it up properly in PayPal business account,
 /// it is documented in docs wiki.
 
-    $req = 'cmd=_notify-validate';
+$req = 'cmd=_notify-validate';
 
-    $data = new object();
+$data = new object();
 
-    foreach ($_POST as $key => $value) {
-        $req .= "&$key=".urlencode($value);
-        $data->$key = $value;
-    }
+foreach ($_POST as $key => $value) {
+    $req .= "&$key=".urlencode($value);
+    $data->$key = $value;
+}
 
-    $custom = explode('-', $data->custom);
-    $data->userid           = (int)$custom[0];
-    $data->courseid         = (int)$custom[1];
-    $data->payment_gross    = $data->mc_gross;
-    $data->payment_currency = $data->mc_currency;
-    $data->timeupdated      = time();
+$custom = explode('-', $data->custom);
+$data->userid           = (int)$custom[0];
+$data->courseid         = (int)$custom[1];
+$data->instanceid       = (int)$custom[2];
+$data->payment_gross    = $data->mc_gross;
+$data->payment_currency = $data->mc_currency;
+$data->timeupdated      = time();
 
 
 /// get the user and course records
 
-    if (! $user = $DB->get_record("user", array("id"=>$data->userid))) {
-        message_paypal_error_to_admin("Not a valid user id", $data);
-        die;
-    }
+if (! $user = $DB->get_record("user", array("id"=>$data->userid))) {
+    message_paypal_error_to_admin("Not a valid user id", $data);
+    die;
+}
 
-    if (! $course = $DB->get_record("course", array("id"=>$data->courseid))) {
-        message_paypal_error_to_admin("Not a valid course id", $data);
-        die;
-    }
+if (! $course = $DB->get_record("course", array("id"=>$data->courseid))) {
+    message_paypal_error_to_admin("Not a valid course id", $data);
+    die;
+}
 
-    if (! $context = get_context_instance(CONTEXT_COURSE, $course->id)) {
-        message_paypal_error_to_admin("Not a valid context id", $data);
-        die;
-    }
+if (! $context = get_context_instance(CONTEXT_COURSE, $course->id)) {
+    message_paypal_error_to_admin("Not a valid context id", $data);
+    die;
+}
 
-/// Open a connection back to PayPal to validate the data
+if (! $plugin_instance = $DB->get_record("enrol", array("id"=>$data->instanceid, "status"=>0))) {
+    message_paypal_error_to_admin("Not a valid instance id", $data);
+    die;
+}
 
-    $header = '';
-    $header .= "POST /cgi-bin/webscr HTTP/1.0\r\n";
-    $header .= "Content-Type: application/x-www-form-urlencoded\r\n";
-    $header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
-    $paypaladdr = empty($CFG->usepaypalsandbox) ? 'www.paypal.com' : 'www.sandbox.paypal.com';
-    $fp = fsockopen ($paypaladdr, 80, $errno, $errstr, 30);
-
-    if (!$fp) {  /// Could not open a socket to PayPal - FAIL
-        echo "<p>Error: could not access paypal.com</p>";
-        message_paypal_error_to_admin("Could not access paypal.com to verify payment", $data);
-        die;
-    }
+$plugin = enrol_get_plugin('paypal');
+
+/// Open a connection back to PayPal to validate the data
+$header = '';
+$header .= "POST /cgi-bin/webscr HTTP/1.0\r\n";
+$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
+$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
+$paypaladdr = empty($CFG->usepaypalsandbox) ? 'www.paypal.com' : 'www.sandbox.paypal.com';
+$fp = fsockopen ($paypaladdr, 80, $errno, $errstr, 30);
+
+if (!$fp) {  /// Could not open a socket to PayPal - FAIL
+    echo "<p>Error: could not access paypal.com</p>";
+    message_paypal_error_to_admin("Could not access paypal.com to verify payment", $data);
+    die;
+}
 
 /// Connection is OK, so now we post the data to validate it
 
-    fputs ($fp, $header.$req);
+fputs ($fp, $header.$req);
 
 /// Now read the response and check if everything is OK.
 
-    while (!feof($fp)) {
-        $result = fgets($fp, 1024);
-        if (strcmp($result, "VERIFIED") == 0) {          // VALID PAYMENT!
+while (!feof($fp)) {
+    $result = fgets($fp, 1024);
+    if (strcmp($result, "VERIFIED") == 0) {          // VALID PAYMENT!
 
 
-            // check the payment_status and payment_reason
+        // check the payment_status and payment_reason
 
-            // If status is not completed or pending then unenrol the student if already enrolled
-            // and notify admin
+        // If status is not completed or pending then unenrol the student if already enrolled
+        // and notify admin
 
-            if ($data->payment_status != "Completed" and $data->payment_status != "Pending") {
-                role_unassign_all(array('userid'=>$data->userid, 'contextid'=>$context->id, 'component'=>'enrol_paypal'), true, true);
-                message_paypal_error_to_admin("Status not completed or pending. User unenrolled from course", $data);
-                die;
-            }
+        if ($data->payment_status != "Completed" and $data->payment_status != "Pending") {
+            $plugin->unenrol_user($plugin_instance, $data->userid);
+            message_paypal_error_to_admin("Status not completed or pending. User unenrolled from course", $data);
+            die;
+        }
 
-            // If currency is incorrectly set then someone maybe trying to cheat the system
+        // If currency is incorrectly set then someone maybe trying to cheat the system
 
-            if ($data->mc_currency != $course->currency) {
-                email_paypal_error_to_admin("Currency does not match course settings, received: ".addslashes($data->mc_currency), $data);
-                die;
-            }
+        if ($data->mc_currency != $plugin_instance->currency) {
+            message_paypal_error_to_admin("Currency does not match course settings, received: ".addslashes($data->mc_currency), $data);
+            die;
+        }
 
-            // If status is pending and reason is other than echeck then we are on hold until further notice
-            // Email user to let them know. Email admin.
+        // If status is pending and reason is other than echeck then we are on hold until further notice
+        // Email user to let them know. Email admin.
+
+        if ($data->payment_status == "Pending" and $data->pending_reason != "echeck") {
+            $eventdata = new object();
+            $eventdata->modulename        = 'moodle';
+            $eventdata->component         = 'enrol_paypal';
+            $eventdata->name              = 'paypal_enrolment';
+            $eventdata->userfrom          = get_admin();
+            $eventdata->userto            = $user;
+            $eventdata->subject           = "Moodle: PayPal payment";
+            $eventdata->fullmessage       = "Your PayPal payment is pending.";
+            $eventdata->fullmessageformat = FORMAT_PLAIN;
+            $eventdata->fullmessagehtml   = '';
+            $eventdata->smallmessage      = '';
+            message_send($eventdata);
+
+            message_paypal_error_to_admin("Payment pending", $data);
+            die;
+        }
 
-            if ($data->payment_status == "Pending" and $data->pending_reason != "echeck") {
-                $eventdata = new object();
-                $eventdata->modulename        = 'moodle';
-                $eventdata->userfrom          = get_admin();
-                $eventdata->userto            = $user;
-                $eventdata->subject           = "Moodle: PayPal payment";
-                $eventdata->fullmessage       = "Your PayPal payment is pending.";
-                $eventdata->fullmessageformat = FORMAT_PLAIN;
-                $eventdata->fullmessagehtml   = '';
-                $eventdata->smallmessage      = '';
-                message_send($eventdata);
+        // If our status is not completed or not pending on an echeck clearance then ignore and die
+        // This check is redundant at present but may be useful if paypal extend the return codes in the future
 
-                message_paypal_error_to_admin("Payment pending", $data);
-                die;
-            }
+        if (! ( $data->payment_status == "Completed" or
+               ($data->payment_status == "Pending" and $data->pending_reason == "echeck") ) ) {
+            die;
+        }
 
-            // If our status is not completed or not pending on an echeck clearance then ignore and die
-            // This check is redundant at present but may be useful if paypal extend the return codes in the future
+        // At this point we only proceed with a status of completed or pending with a reason of echeck
 
-            if (! ( $data->payment_status == "Completed" or
-                   ($data->payment_status == "Pending" and $data->pending_reason == "echeck") ) ) {
-                die;
-            }
 
-            // At this point we only proceed with a status of completed or pending with a reason of echeck
 
+        if ($existing = $DB->get_record("enrol_paypal", array("txn_id"=>$data->txn_id))) {   // Make sure this transaction doesn't exist already
+            message_paypal_error_to_admin("Transaction $data->txn_id is being repeated!", $data);
+            die;
 
+        }
 
-            if ($existing = $DB->get_record("enrol_paypal", array("txn_id"=>$data->txn_id))) {   // Make sure this transaction doesn't exist already
-                message_paypal_error_to_admin("Transaction $data->txn_id is being repeated!", $data);
-                die;
+        if ($data->business != $plugin->get_config('paypalbusiness')) {   // Check that the email is the one we want it to be
+            message_paypal_error_to_admin("Business email is {$data->business} (not ".
+                    $plugin->get_config('paypalbusiness').")", $data);
+            die;
 
-            }
+        }
 
-            if ($data->business != $CFG->enrol_paypalbusiness) {   // Check that the email is the one we want it to be
-                message_paypal_error_to_admin("Business email is $data->business (not $CFG->enrol_paypalbusiness)", $data);
-                die;
+        if (!$user = $DB->get_record('user', array('id'=>$data->userid))) {   // Check that user exists
+            message_paypal_error_to_admin("User $data->userid doesn't exist", $data);
+            die;
+        }
 
-            }
+        if (!$course = $DB->get_record('course', array('id'=>$data->courseid))) { // Check that course exists
+            message_paypal_error_to_admin("Course $data->courseid doesn't exist", $data);;
+            die;
+        }
 
-            if (!$user = $DB->get_record('user', array('id'=>$data->userid))) {   // Check that user exists
-                message_paypal_error_to_admin("User $data->userid doesn't exist", $data);
-                die;
-            }
+        // Check that amount paid is the correct amount
+        if ( (float) $plugin_instance->cost <= 0 ) {
+            $cost = (float) $plugin->get_config('cost');
+        } else {
+            $cost = (float) $plugin_instance->cost;
+        }
 
-            if (!$course = $DB->get_record('course', array('id'=>$data->courseid))) { // Check that course exists
-                message_paypal_error_to_admin("Course $data->courseid doesn't exist", $data);;
-                die;
-            }
+        if ($data->payment_gross < $cost) {
+            $cost = format_float($cost, 2);
+            message_paypal_error_to_admin("Amount paid is not enough ($data->payment_gross < $cost))", $data);
+            die;
 
-            // Check that amount paid is the correct amount
-            if ( (float) $course->cost < 0 ) {
-                $cost = (float) $CFG->enrol_cost;
-            } else {
-                $cost = (float) $course->cost;
-            }
+        }
 
-            if ($data->payment_gross < $cost) {
-                $cost = format_float($cost, 2);
-                message_paypal_error_to_admin("Amount paid is not enough ($data->payment_gross < $cost))", $data);
-                die;
+        // ALL CLEAR !
 
-            }
+        $DB->insert_record("enrol_paypal", $data);
 
-            // ALL CLEAR !
-
-            $DB->insert_record("enrol_paypal", $data);
-
-            if (!enrol_into_course($course, $user, 'paypal')) {
-                message_paypal_error_to_admin("Error while trying to enrol ".fullname($user)." in '$course->fullname'", $data);
-                die;
-            } else {
-                // Pass $view=true to filter hidden caps if the user cannot see them
-                if ($users = get_users_by_capability($context, 'moodle/course:update', 'u.*', 'u.id ASC',
-                                                     '', '', '', '', false, true)) {
-                    $users = sort_by_roleassignment_authority($users, $context);
-                    $teacher = array_shift($users);
-                } else {
-                    $teacher = false;
-                }
-
-
-                if (!empty($CFG->enrol_mailstudents)) {
-                    $a->coursename = $course->fullname;
-                    $a->profileurl = "$CFG->wwwroot/user/view.php?id=$user->id";
-
-                    $eventdata = new object();
-                    $eventdata->modulename        = 'moodle';
-                    $eventdata->userfrom          = $teacher;
-                    $eventdata->userto            = $user;
-                    $eventdata->subject           = get_string("enrolmentnew", '', $course->shortname);
-                    $eventdata->fullmessage       = get_string('welcometocoursetext', '', $a);
-                    $eventdata->fullmessageformat = FORMAT_PLAIN;
-                    $eventdata->fullmessagehtml   = '';
-                    $eventdata->smallmessage      = '';
-                    message_send($eventdata);
-
-                }
-
-                if (!empty($CFG->enrol_mailteachers)) {
-                    $a->course = $course->fullname;
-                    $a->user = fullname($user);
-
-                    $eventdata = new object();
-                    $eventdata->modulename        = 'moodle';
-                    $eventdata->userfrom          = $user;
-                    $eventdata->userto            = $teacher;
-                    $eventdata->subject           = get_string("enrolmentnew", '', $course->shortname);
-                    $eventdata->fullmessage       = get_string('enrolmentnewuser', '', $a);
-                    $eventdata->fullmessageformat = FORMAT_PLAIN;
-                    $eventdata->fullmessagehtml   = '';
-                    $eventdata->smallmessage      = '';
-                    message_send($eventdata);
-                }
-
-                if (!empty($CFG->enrol_mailadmins)) {
-                    $a->course = $course->fullname;
-                    $a->user = fullname($user);
-                    $admins = get_admins();
-                    foreach ($admins as $admin) {
-                        $eventdata = new object();
-                        $eventdata->modulename        = 'moodle';
-                        $eventdata->userfrom          = $user;
-                        $eventdata->userto            = $admin;
-                        $eventdata->subject           = get_string("enrolmentnew", '', $course->shortname);
-                        $eventdata->fullmessage       = get_string('enrolmentnewuser', '', $a);
-                        $eventdata->fullmessageformat = FORMAT_PLAIN;
-                        $eventdata->fullmessagehtml   = '';
-                        $eventdata->smallmessage      = '';
-                        message_send($eventdata);
-                    }
-                }
+        if ($plugin_instance->enrolperiod) {
+            $timestart = time();
+            $timeend   = $timestart + $plugin_instance->enrolperiod;
+        } else {
+            $timestart = 0;
+            $timeend   = 0;
+        }
 
-            }
+        // Enrol user
+        $plugin->enrol_user($plugin_instance, $user->id, $plugin_instance->roleid, $timestart, $timeend);
 
+        // Pass $view=true to filter hidden caps if the user cannot see them
+        if ($users = get_users_by_capability($context, 'moodle/course:update', 'u.*', 'u.id ASC',
+                                             '', '', '', '', false, true)) {
+            $users = sort_by_roleassignment_authority($users, $context);
+            $teacher = array_shift($users);
+        } else {
+            $teacher = false;
+        }
+
+        $mailstudents = $plugin->get_config('mailstudents');
+        $mailteachers = $plugin->get_config('mailteachers');
+        $mailadmins   = $plugin->get_config('mailadmins');
+
+        if (!empty($mailstudents)) {
+            $a->coursename = $course->fullname;
+            $a->profileurl = "$CFG->wwwroot/user/view.php?id=$user->id";
+
+            $eventdata = new object();
+            $eventdata->modulename        = 'moodle';
+            $eventdata->component         = 'enrol_paypal';
+            $eventdata->name              = 'paypal_enrolment';
+            $eventdata->userfrom          = $teacher;
+            $eventdata->userto            = $user;
+            $eventdata->subject           = get_string("enrolmentnew", '', $course->shortname);
+            $eventdata->fullmessage       = get_string('welcometocoursetext', '', $a);
+            $eventdata->fullmessageformat = FORMAT_PLAIN;
+            $eventdata->fullmessagehtml   = '';
+            $eventdata->smallmessage      = '';
+            message_send($eventdata);
 
-        } else if (strcmp ($result, "INVALID") == 0) { // ERROR
-            $DB->insert_record("enrol_paypal", $data, false);
-            message_paypal_error_to_admin("Received an invalid payment notification!! (Fake payment?)", $data);
         }
-    }
 
-    fclose($fp);
-    exit;
+        if (!empty($mailteachers)) {
+            $a->course = $course->fullname;
+            $a->user = fullname($user);
+
+            $eventdata = new object();
+            $eventdata->modulename        = 'moodle';
+            $eventdata->component         = 'enrol_paypal';
+            $eventdata->name              = 'paypal_enrolment';
+            $eventdata->userfrom          = $user;
+            $eventdata->userto            = $teacher;
+            $eventdata->subject           = get_string("enrolmentnew", '', $course->shortname);
+            $eventdata->fullmessage       = get_string('enrolmentnewuser', '', $a);
+            $eventdata->fullmessageformat = FORMAT_PLAIN;
+            $eventdata->fullmessagehtml   = '';
+            $eventdata->smallmessage      = '';
+            message_send($eventdata);
+        }
+
+        if (!empty($mailadmins)) {
+            $a->course = $course->fullname;
+            $a->user = fullname($user);
+            $admins = get_admins();
+            foreach ($admins as $admin) {
+                $eventdata = new object();
+                $eventdata->modulename        = 'moodle';
+                $eventdata->component         = 'enrol_paypal';
+                $eventdata->name              = 'paypal_enrolment';
+                $eventdata->userfrom          = $user;
+                $eventdata->userto            = $admin;
+                $eventdata->subject           = get_string("enrolmentnew", '', $course->shortname);
+                $eventdata->fullmessage       = get_string('enrolmentnewuser', '', $a);
+                $eventdata->fullmessageformat = FORMAT_PLAIN;
+                $eventdata->fullmessagehtml   = '';
+                $eventdata->smallmessage      = '';
+                message_send($eventdata);
+            }
+        }
+
+    } else if (strcmp ($result, "INVALID") == 0) { // ERROR
+        $DB->insert_record("enrol_paypal", $data, false);
+        message_paypal_error_to_admin("Received an invalid payment notification!! (Fake payment?)", $data);
+    }
+}
 
+fclose($fp);
+exit;
 
 
-/// FUNCTIONS //////////////////////////////////////////////////////////////////
+//--- HELPER FUNCTIONS --------------------------------------------------------------------------------------
 
 
 function message_paypal_error_to_admin($subject, $data) {
+    echo $subject;
     $admin = get_admin();
     $site = get_site();
 
@@ -270,6 +314,8 @@ function message_paypal_error_to_admin($subject, $data) {
 
     $eventdata = new object();
     $eventdata->modulename        = 'moodle';
+    $eventdata->component         = 'enrol_paypal';
+    $eventdata->name              = 'paypal_enrolment';
     $eventdata->userfrom          = $admin;
     $eventdata->userto            = $admin;
     $eventdata->subject           = "PAYPAL ERROR: ".$subject;
diff --git a/enrol/paypal/lang/en/enrol_paypal.php b/enrol/paypal/lang/en/enrol_paypal.php
index a48a79b..b4c1c30 100644
--- a/enrol/paypal/lang/en/enrol_paypal.php
+++ b/enrol/paypal/lang/en/enrol_paypal.php
@@ -23,9 +23,27 @@
  * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
  */
 
-$string['business'] = 'The email address of your business PayPal account';
+$string['defaultrole'] = 'Default role assignment';
+$string['defaultrole_desc'] = 'Select role which should be assigned to users during PayPal enrolments';
+$string['status'] = 'Allow PayPal enrolments';
+$string['status_desc'] = 'Allow users to use PayPal to enrol into a course by default.';
+$string['enrolperiod'] = 'Enrolment period';
+$string['enrolperiod_desc'] = 'Default length of the enrolment period (in seconds).'; //TODO: fixme
 $string['costorkey'] = 'Please choose one of the following methods of enrolment.';
-$string['description'] = 'The PayPal module allows you to set up paid courses.  If the cost for any course is zero, then students are not asked to pay for entry.  There is a site-wide cost that you set here as a default for the whole site and then a course setting that you can set for each course individually. The course cost overrides the site cost.';
-$string['enrolname'] = 'PayPal';
+$string['pluginname_desc'] = 'The PayPal module allows you to set up paid courses.  If the cost for any course is zero, then students are not asked to pay for entry.  There is a site-wide cost that you set here as a default for the whole site and then a course setting that you can set for each course individually. The course cost overrides the site cost.';
+$string['pluginname'] = 'PayPal';
 $string['paypalaccepted'] = 'PayPal payments accepted';
 $string['sendpaymentbutton'] = 'Send payment via PayPal';
+$string['cost'] = 'Enrol Cost';
+$string['currency'] = 'Currency';
+$string['businessemail'] = 'PayPal business email';
+$string['businessemail_desc'] = 'The email address of your business PayPal account';
+$string['mailstudents'] = 'Notify students';
+$string['mailteachers'] = 'Notify teachers';
+$string['mailadmins'] = 'Notify admin';
+$string['assignrole'] = 'Assign role';
+$string['enrolstartdate'] = 'Start date';
+$string['enrolenddate'] = 'End date';
+$string['enrolenddaterror'] = 'Enrolment end date cannot be earlier than start date';
+$string['costerror'] = 'The enrolment cost is not numeric';
+$string['nocost'] = 'There is no cost associated with enrolling in this course!';
diff --git a/enrol/paypal/lib.php b/enrol/paypal/lib.php
new file mode 100644
index 0000000..4add3e4
--- /dev/null
+++ b/enrol/paypal/lib.php
@@ -0,0 +1,354 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Paypal enrolment plugin.
+ *
+ * This plugin allows you to set up paid courses.
+ *
+ * @package   enrol_paypal
+ * @copyright 2010 Eugene Venter
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/**
+ * Paypal enrolment plugin implementation.
+ * @author  Eugene Venter - based on code by Martin Dougiamas and others
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+class enrol_paypal_plugin extends enrol_plugin {
+
+    /**
+     * Add new instance of enrol plugin with default settings.
+     * @param object $course
+     * @return int id of new instance
+     */
+    public function add_default_instance($course) {
+        global $DB;
+
+        $exists = $DB->record_exists('enrol', array('courseid'=>$course->id, 'enrol'=>'paypal'));
+
+        $fields = array('enrolperiod'=>$this->get_config('enrolperiod', 0),
+                        'roleid'=>$this->get_config('roleid', 0),
+                        'cost'=>$this->get_config('cost', 0),
+                        'currency'=>$this->get_config('currency', 0)
+                       );
+
+        $fields['status'] = $exists ? ENROL_INSTANCE_DISABLED : $this->get_config('status');
+
+        return $this->add_instance($course, $fields);
+    }
+
+    /**
+     * Returns link to page which may be used to add new instance of enrolment plugin in course.
+     * @param int $courseid
+     * @return moodle_url page url
+     */
+    public function get_candidate_link($courseid) {
+        if (!has_capability('moodle/course:enrolconfig', get_context_instance(CONTEXT_COURSE, $courseid, MUST_EXIST))) {
+            return NULL;
+        }
+        // multiple instances supported - different roles with different password
+        return new moodle_url('/enrol/paypal/addinstance.php', array('sesskey'=>sesskey(), 'id'=>$courseid));
+    }
+
+    /**
+     * Adds enrol instance UI to course edit form
+     *
+     * @param object $instance enrol instance or null if does not exist yet
+     * @param MoodleQuickForm $mform
+     * @param object $data
+     * @param object $context context of existing course or parent category if course does not exist
+     * @return void
+     */
+    public function course_edit_form($instance, MoodleQuickForm $mform, $data, $context) {
+
+        $i = isset($instance->id) ? $instance->id : 0;
+        $plugin = enrol_get_plugin('paypal');
+        $header = $plugin->get_instance_name($instance);
+        $config = has_capability('moodle/course:enrolconfig', $context);
+
+        $mform->addElement('header', 'enrol_paypal_header_'.$i, $header);
+
+
+        $options = array(ENROL_INSTANCE_ENABLED  => get_string('yes'),
+                         ENROL_INSTANCE_DISABLED => get_string('no'));
+        $mform->addElement('select', 'enrol_paypal_status_'.$i, get_string('status', 'enrol_paypal'), $options);
+        $mform->setDefault('enrol_paypal_status_'.$i, $this->get_config('status'));
+        $mform->setAdvanced('enrol_paypal_status_'.$i, $this->get_config('status_adv'));
+        if (!$config) {
+            $mform->hardFreeze('enrol_paypal_status_'.$i);
+        }
+
+        $mform->addElement('text', 'enrol_paypal_cost_'.$i, get_string('cost', 'enrol_paypal'), array('size'=>4));
+        $mform->setDefault('enrol_paypal_cost_'.$i, $this->get_config('cost'));
+        if (!$config) {
+            $mform->hardFreeze('enrol_paypal_cost_'.$i);
+        } else {
+            $mform->disabledIf('enrol_paypal_cost_'.$i, 'enrol_paypal_status_'.$i, 'noteq', ENROL_INSTANCE_ENABLED);
+        }
+
+        $paypalcurrencies = array(  'USD' => 'US Dollars',
+                                    'EUR' => 'Euros',
+                                    'JPY' => 'Japanese Yen',
+                                    'GBP' => 'British Pounds',
+                                    'CAD' => 'Canadian Dollars',
+                                    'AUD' => 'Australian Dollars'
+                                    );
+        $mform->addElement('select', 'enrol_paypal_currency_'.$i, get_string('currency', 'enrol_paypal'), $paypalcurrencies);
+        $mform->setDefault('enrol_paypal_currency_'.$i, $this->get_config('currency'));
+        if (!$config) {
+            $mform->hardFreeze('enrol_paypal_currency_'.$i);
+        } else {
+            $mform->disabledIf('enrol_paypal_currency_'.$i, 'enrol_paypal_status_'.$i, 'noteq', ENROL_INSTANCE_ENABLED);
+        }
+
+
+        if ($instance) {
+            $roles = get_default_enrol_roles($context, $instance->roleid);
+        } else {
+            $roles = get_default_enrol_roles($context, $this->get_config('roleid'));
+        }
+        $mform->addElement('select', 'enrol_paypal_roleid_'.$i, get_string('assignrole', 'enrol_paypal'), $roles);
+        $mform->setDefault('enrol_paypal_roleid_'.$i, $this->get_config('roleid'));
+        $mform->setAdvanced('enrol_paypal_roleid_'.$i, $this->get_config('roleid_adv'));
+        if (!$config) {
+            $mform->hardFreeze('enrol_paypal_roleid_'.$i);
+        } else {
+            $mform->disabledIf('enrol_paypal_roleid_'.$i, 'enrol_paypal_status_'.$i, 'noteq', ENROL_INSTANCE_ENABLED);
+        }
+
+
+        $mform->addElement('duration', 'enrol_paypal_enrolperiod_'.$i, get_string('enrolperiod', 'enrol_paypal'), array('optional' => true, 'defaultunit' => 86400));
+        $mform->setDefault('enrol_paypal_enrolperiod_'.$i, $this->get_config('enrolperiod'));
+        $mform->setAdvanced('enrol_paypal_enrolperiod_'.$i, $this->get_config('enrolperiod_adv'));
+        if (!$config) {
+            $mform->hardFreeze('enrol_paypal_enrolperiod_'.$i);
+        } else {
+            $mform->disabledIf('enrol_paypal_enrolperiod_'.$i, 'enrol_paypal_status_'.$i, 'noteq', ENROL_INSTANCE_ENABLED);
+        }
+
+
+        $mform->addElement('date_selector', 'enrol_paypal_enrolstartdate_'.$i, get_string('enrolstartdate', 'enrol_paypal'), array('optional' => true));
+        $mform->setDefault('enrol_paypal_enrolstartdate_'.$i, 0);
+        $mform->setAdvanced('enrol_paypal_enrolstartdate_'.$i, 1);
+        if (!$config) {
+            $mform->hardFreeze('enrol_paypal_enrolstartdate_'.$i);
+        } else {
+            $mform->disabledIf('enrol_paypal_enrolstartdate_'.$i, 'enrol_paypal_status_'.$i, 'noteq', ENROL_INSTANCE_ENABLED);
+        }
+
+
+        $mform->addElement('date_selector', 'enrol_paypal_enrolenddate_'.$i, get_string('enrolenddate', 'enrol_paypal'), array('optional' => true));
+        $mform->setDefault('enrol_paypal_enrolenddate_'.$i, 0);
+        $mform->setAdvanced('enrol_paypal_enrolenddate_'.$i, 1);
+        if (!$config) {
+            $mform->hardFreeze('enrol_paypal_enrolenddate_'.$i);
+        } else {
+            $mform->disabledIf('enrol_paypal_enrolenddate_'.$i, 'enrol_paypal_status_'.$i, 'noteq', ENROL_INSTANCE_ENABLED);
+        }
+
+
+        // now add all values from enrol table
+        if ($instance) {
+            foreach($instance as $key=>$val) {
+                $data->{'enrol_paypal_'.$key.'_'.$i} = $val;
+            }
+        }
+    }
+
+    /**
+     * Validates course edit form data
+     *
+     * @param object $instance enrol instance or null if does not exist yet
+     * @param array $data
+     * @param object $context context of existing course or parent category if course does not exist
+     * @return array errors array
+     */
+    public function course_edit_validation($instance, array $data, $context) {
+        $errors = array();
+
+        if (!has_capability('moodle/course:enrolconfig', $context)) {
+            // we are going to ignore the data later anyway, they would not be able to fix the form anyway
+            return $errors;
+        }
+
+        $i = isset($instance->id) ? $instance->id : 0;
+
+        if ($data['enrol_paypal_status_'.$i] == ENROL_INSTANCE_ENABLED) {
+            if (!empty($data['enrol_paypal_enrolenddate_'.$i]) and $data['enrol_paypal_enrolenddate_'.$i] < $data['enrol_paypal_enrolstartdate_'.$i]) {
+                $errors['enrol_paypal_enrolenddate_'.$i] = get_string('enrolenddaterror', 'enrol_paypal');
+            }
+
+            if (!is_numeric($data['enrol_paypal_cost_'.$i])) {
+                $errors['enrol_paypal_cost_'.$i] = get_string('costerror', 'enrol_paypal');
+
+            }
+        }
+
+        return $errors;
+    }
+
+
+    /**
+     * Called after updating/inserting course.
+     *
+     * @param bool $inserted true if course just inserted
+     * @param object $course
+     * @param object $data form data
+     * @return void
+     */
+    public function course_updated($inserted, $course, $data) {
+        global $DB;
+
+        $context = get_context_instance(CONTEXT_COURSE, $course->id);
+
+        if (has_capability('moodle/course:enrolconfig', $context)) {
+            if ($inserted) {
+                if (isset($data->enrol_paypal_status_0)) {
+                    $fields = array('status'=>$data->enrol_paypal_status_0);
+                    if ($fields['status'] == ENROL_INSTANCE_ENABLED) {
+                        $fields['cost']           = $data->enrol_paypal_cost_0;
+                        $fields['currency']       = $data->enrol_paypal_currency_0;
+                        $fields['roleid']         = $data->enrol_paypal_roleid_0;
+                        $fields['enrolperiod']    = $data->enrol_paypal_enrolperiod_0;
+                        $fields['enrolstartdate'] = $data->enrol_paypal_enrolstartdate_0;
+                        $fields['enrolenddate']   = $data->enrol_paypal_enrolenddate_0;
+                    } else {
+                        $fields['roleid']         = $this->get_config('roleid');
+                        $fields['cost']           = $this->get_config('cost');
+                        $fields['currency']       = $this->get_config('currency');
+                        $fields['enrolperiod']    = $this->get_config('enrolperiod');
+                        $fields['enrolstartdate'] = 0;
+                        $fields['enrolenddate']   = 0;
+                    }
+                    $this->add_instance($course, $fields);
+                }
+
+            } else {
+                $instances = $DB->get_records('enrol', array('courseid'=>$course->id, 'enrol'=>'paypal'));
+                foreach ($instances as $instance) {
+                    $i = $instance->id;
+
+                    if (isset($data->{'enrol_paypal_status_'.$i})) {
+                        $instance->status       = $data->{'enrol_paypal_status_'.$i};
+                        $instance->timemodified = time();
+                        if ($instance->status == ENROL_INSTANCE_ENABLED) {
+                            $instance->roleid         = $data->{'enrol_paypal_roleid_'.$i};
+                            $instance->cost           = $data->{'enrol_paypal_cost_'.$i};
+                            $instance->currency       = $data->{'enrol_paypal_currency_'.$i};
+                            $instance->enrolperiod    = $data->{'enrol_paypal_enrolperiod_'.$i};
+                            $instance->enrolstartdate = $data->{'enrol_paypal_enrolstartdate_'.$i};
+                            $instance->enrolenddate   = $data->{'enrol_paypal_enrolenddate_'.$i};
+                        }
+                        $DB->update_record('enrol', $instance);
+                    }
+                }
+            }
+
+        } else {
+            if ($inserted) {
+                if ($this->get_config('defaultenrol')) {
+                    $this->add_default_instance($course);
+                }
+            } else {
+                // bad luck, user can not change anything
+            }
+        }
+    }
+
+
+    /**
+     * Creates course enrol form, checks if form submitted
+     * and enrols user if necessary. It can also redirect.
+     *
+     * @param stdClass $instance
+     * @return string html text, usually a form in a text box
+     */
+    function enrol_page_hook(stdClass $instance) {
+        global $CFG, $USER, $OUTPUT, $PAGE, $DB;
+
+        ob_start();
+
+        if ($DB->record_exists('user_enrolments', array('userid'=>$USER->id, 'enrolid'=>$instance->id))) {
+            return ob_get_clean();
+        }
+
+        if ($instance->enrolstartdate != 0 && $instance->enrolstartdate > time()) {
+            return ob_get_clean();
+        }
+
+        if ($instance->enrolenddate != 0 && $instance->enrolenddate < time()) {
+            return ob_get_clean();
+        }
+
+        $course = $DB->get_record('course', array('id'=>$instance->courseid));
+
+        $strloginto = get_string("loginto", "", $course->shortname);
+        $strcourses = get_string("courses");
+
+        $context = get_context_instance(CONTEXT_COURSE, $course->id);
+        // Pass $view=true to filter hidden caps if the user cannot see them
+        if ($users = get_users_by_capability($context, 'moodle/course:update', 'u.*', 'u.id ASC',
+                                             '', '', '', '', false, true)) {
+            $users = sort_by_roleassignment_authority($users, $context);
+            $teacher = array_shift($users);
+        } else {
+            $teacher = false;
+        }
+
+        if ( (float) $instance->cost <= 0 ) {
+            $cost = (float) $this->get_config('cost');
+        } else {
+            $cost = (float) $instance->cost;
+        }
+
+        if (abs($cost) < 0.01) { // no cost, other enrolment methods (instances) should be used
+            echo '<p>'.get_string('nocost', 'enrol_paypal').'</p>';
+        } else {
+
+            if ($USER->username == 'guest') { // force login only for guest user, not real users with guest role
+                if (empty($CFG->loginhttps)) {
+                    $wwwroot = $CFG->wwwroot;
+                } else {
+                    // This actually is not so secure ;-), 'cause we're
+                    // in unencrypted connection...
+                    $wwwroot = str_replace("http://", "https://", $CFG->wwwroot);
+                }
+                echo '<div class="mdl-align"><p>'.get_string('paymentrequired').'</p>';
+                echo '<p><b>'.get_string('cost').": $CFG->enrol_currency $cost".'</b></p>';
+                echo '<p><a href="'.$wwwroot.'/login/">'.get_string('loginsite').'</a></p>';
+                echo '</div>';
+            } else {
+                //Sanitise some fields before building the PayPal form
+                $coursefullname  = $course->fullname;
+                $courseshortname = $course->shortname;
+                $userfullname    = fullname($USER);
+                $userfirstname   = $USER->firstname;
+                $userlastname    = $USER->lastname;
+                $useraddress     = $USER->address;
+                $usercity        = $USER->city;
+
+                include($CFG->dirroot.'/enrol/paypal/enrol.html');
+            }
+
+        }
+
+        return $OUTPUT->box(ob_get_clean());
+    } // enrol_page_hook
+
+} // class
diff --git a/enrol/paypal/return.php b/enrol/paypal/return.php
index 6d2f4ce..6eb9e3e 100644
--- a/enrol/paypal/return.php
+++ b/enrol/paypal/return.php
@@ -1,7 +1,7 @@
 <?php
 
     require("../../config.php");
-    require_once("$CFG->dirroot/enrol/paypal/enrol.php");
+    require_once("$CFG->dirroot/enrol/paypal/lib.php");
 
     $id = required_param('id', PARAM_INT);
 
@@ -31,7 +31,10 @@
     } else {   /// Somehow they aren't enrolled yet!  :-(
         $PAGE->set_url($destination);
         echo $OUTPUT->header();
-        notice(get_string('paymentsorry', '', get_string('defaultcourseteacher')), $destination);
+        $a = new stdClass();
+        $a->teacher = get_string('defaultcourseteacher');
+        $a->fullname = format_string($course->fullname);
+        notice(get_string('paymentsorry', '', $a), $destination);
     }
 
 
diff --git a/enrol/paypal/settings.php b/enrol/paypal/settings.php
new file mode 100644
index 0000000..3abec92
--- /dev/null
+++ b/enrol/paypal/settings.php
@@ -0,0 +1,79 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Paypal enrolments plugin settings and presets.
+ *
+ * @package   enrol_paypal
+ * @copyright 2010 Eugene Venter
+ * @author    Eugene Venter - based on code by Petr Skoda and others
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+defined('MOODLE_INTERNAL') || die;
+
+if ($ADMIN->fulltree) {
+
+    //--- settings ------------------------------------------------------------------------------------------
+    $settings->add(new admin_setting_heading('enrol_paypal_settings', '', get_string('pluginname_desc', 'enrol_paypal')));
+
+    $settings->add(new admin_setting_configtext('enrol_paypal/paypalbusiness', get_string('businessemail', 'enrol_paypal'), get_string('businessemail_desc', 'enrol_paypal'), '', PARAM_EMAIL));
+
+    $settings->add(new admin_setting_configcheckbox('enrol_paypal/mailstudents', get_string('mailstudents', 'enrol_paypal'), '', 0));
+
+    $settings->add(new admin_setting_configcheckbox('enrol_paypal/mailteachers', get_string('mailteachers', 'enrol_paypal'), '', 0));
+
+    $settings->add(new admin_setting_configcheckbox('enrol_paypal/mailadmins', get_string('mailadmins', 'enrol_paypal'), '', 0));
+
+    //--- enrol instance defaults ----------------------------------------------------------------------------
+    $settings->add(new admin_setting_heading('enrol_paypal_defaults',
+        get_string('enrolinstancedefaults', 'admin'), get_string('enrolinstancedefaults_desc', 'admin')));
+
+    $settings->add(new admin_setting_configtext('enrol_paypal/cost', get_string('cost', 'enrol_paypal'), '', 0, PARAM_FLOAT, 4));
+
+    $paypalcurrencies = array(  'USD' => 'US Dollars',
+                                'EUR' => 'Euros',
+                                'JPY' => 'Japanese Yen',
+                                'GBP' => 'British Pounds',
+                                'CAD' => 'Canadian Dollars',
+                                'AUD' => 'Australian Dollars'
+                            );
+
+    $settings->add(new admin_setting_configselect('enrol_paypal/currency', get_string('currency', 'enrol_paypal'), '', 'idnumber', $paypalcurrencies));
+
+    $settings->add(new admin_setting_configcheckbox('enrol_paypal/defaultenrol',
+        get_string('defaultenrol', 'enrol'), get_string('defaultenrol_desc', 'enrol'), 0));
+
+    $options = array(ENROL_INSTANCE_ENABLED  => get_string('yes'),
+                     ENROL_INSTANCE_DISABLED => get_string('no'));
+    $settings->add(new admin_setting_configselect_with_advanced('enrol_paypal/status',
+        get_string('status', 'enrol_paypal'), get_string('status_desc', 'enrol_paypal'),
+        array('value'=>ENROL_INSTANCE_DISABLED, 'adv'=>false), $options));
+
+    if (!during_initial_install()) {
+        $options = get_default_enrol_roles(get_context_instance(CONTEXT_SYSTEM));
+        $student = get_archetype_roles('student');
+        $student = reset($student);
+        $settings->add(new admin_setting_configselect_with_advanced('enrol_paypal/roleid',
+            get_string('defaultrole', 'enrol_paypal'), get_string('defaultrole_desc', 'enrol_paypal'),
+            array('value'=>$student->id, 'adv'=>false), $options));
+    }
+
+    $settings->add(new admin_setting_configtext_with_advanced('enrol_paypal/enrolperiod',
+        get_string('enrolperiod', 'enrol_paypal'), get_string('enrolperiod_desc', 'enrol_paypal'),
+        array('value'=>0, 'adv'=>true), PARAM_INT));
+}
diff --git a/enrol/paypal/version.php b/enrol/paypal/version.php
index 5efaf03..5fd6315 100644
--- a/enrol/paypal/version.php
+++ b/enrol/paypal/version.php
@@ -1,12 +1,27 @@
 <?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
 
-/////////////////////////////////////////////////////////////////////////////////
-///  Code fragment to define the version of this enrolment module
-///  This fragment is called by admin/index.php
-/////////////////////////////////////////////////////////////////////////////////
-
-$plugin->version  = 2006092200;   // This module's version
+/**
+ * Paypal enrolment plugin version specification.
+ *
+ * @package   enrol_paypal
+ * @copyright 2010 Eugene Venter
+ * @author Eugene Venter
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
 
+$plugin->version  = 2010071500;
 $plugin->requires = 2007101000;   // Requires this Moodle version
-
-
